library ieee;
use work.DE2_CONSTANTS.all;
use IEEE.std_logic_1164.all;
use IEEE.STD_LOGIC_UNSIGNED.all;

-- SIGNED and UNSIGNED types, and relevant functions
use ieee.numeric_std.all;

-- Basic sequential functions and concurrent procedures
use ieee.VITAL_Primitives.all;
--actually, this is a frequency counter to divide frequency from 50M Hz to 200Hz
--50 000 000/2500000(cycles)/2=125000 then minus 1


entity frequency_divider is
   port(	
	
	    clk_in:in std_logic;
		 reset :in std_logic;
		 coe_clkout:out std_logic;
		 factor_a:in std_logic_vector(31 downto 0);
		 coe_LED : out std_logic_vector(15 downto 0));

end frequency_divider;

architecture Behavioral of frequency_divider is
    signal temp:std_logic;
	 signal counter: std_logic_vector(31 downto 0) :=(others=>'0');
begin
	 frequency_divider:process (reset,clk_in) 
	 begin
	    if (reset='1') then
		    temp<='0';
			 counter<=(others=>'0');
		  elsif rising_edge(clk_in) then
		    if (counter>factor_a) then
			      counter<=(others=>'0');
			 elsif (counter=factor_a)then
			    temp<=NOT (temp);
				 counter<=(others=>'0');
			 elsif (counter<factor_a)then
			    counter<=counter+1;
			 end if;
		 end if;
	end process;
	
	coe_clkout<=temp;
end behavioral;